Bug 188446 - libstdc++so7.spec should use gcc_target_platform
libstdc++so7.spec should use gcc_target_platform
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: libstdc++so7 (Show other bugs)
5
powerpc Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
: EasyFix
Depends On:
Blocks: FC5Update 188443
  Show dependency treegraph
 
Reported: 2006-04-10 01:06 EDT by Jens Petersen
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-09-01 04:35:30 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
libstdc++so7.spec-gcc_target_platform.patch (2.67 KB, patch)
2006-04-10 22:30 EDT, Jens Petersen
no flags Details | Diff

  None (edit)
Description Jens Petersen 2006-04-10 01:06:40 EDT
Description of problem:
libstdc++so7.spec packages its libs under /usr/lib/gcc/%{_target_platform}/
unlike gcc.spec which puts them under /usr/lib/gcc/%{gcc_target_platform}.
This breaks linking of libs with libtool since it tries to link with
"-L/usr/lib/gcc/%{gcc_target_platform}".

eg:

$ rpm -qp --requires scim-libs-1.4.4-9.1.fc5.ppc.rpm | grep CXXABI
libstdc++.so.6(CXXABI_1.3)

whereas

$ rpm -qp --requires scim-1.4.4-9.1.fc5.ppc.rpm | grep CXXABI
libstdc++-20060203.so.7(CXXABI_1.4)

I think libstdc++so7.spec needs to use the gcc_target_platform
macro like gcc.spec does, with:

%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
Comment 1 Benjamin Kosnik 2006-04-10 14:32:16 EDT
jens, your analysis looks correct. Please feel free to do a patch that
implements this...
Comment 2 Jens Petersen 2006-04-10 20:13:00 EDT
Okay, sure.  Perhaps %multilib_32_arch should be ported too?
Comment 3 Jens Petersen 2006-04-10 22:30:36 EDT
Created attachment 127588 [details]
libstdc++so7.spec-gcc_target_platform.patch

This patch should implement the fix.
Comment 4 Jens Petersen 2006-04-26 02:55:36 EDT
I built libstdc++so7-4.2.0-0.3.20060203.3 with the above patch for fc5-updates
to address this issue.
Comment 5 Fedora Update System 2006-04-27 10:35:48 EDT
libstdc++so7-4.2.0-0.3.20060203.3 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 6 Fedora Update System 2006-04-28 15:57:51 EDT
libstdc++so7-4.2.0-0.3.20060203.3 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 7 Jens Petersen 2006-05-09 07:07:23 EDT
Unfortunately the wrapper script is still broken on ppc.

The following change (tested on ppc and ppc64) seems to fix it.

--- libstdc++7.spec	4 May 2006 10:25:26 -0000	1.5
+++ libstdc++7.spec	9 May 2006 11:07:57 -0000
@@ -124,7 +124,7 @@
 cat >> $RPM_BUILD_ROOT%{_bindir}/g++-libstdc++-so_7 <<\EOF
 libversion=4.2.0-%{datestamp}
 includepath=include/c++/$libversion
-%ifarch %{ix86} x86_64 ppc ppc64 s390 s390x sparc sparc64
+%ifarch %{ix86} x86_64 s390 s390x sparc sparc64
 M=`echo "$*" | LC_ALL=C sed -n
's/^.*[[:blank:]]\(-m[63][421]\)\([[:blank:]].*$\|$\)/\1/p'`
 D=`/usr/bin/gcc -print-multi-os-directory $M`
 %endif
@@ -135,10 +135,7 @@
 esac
 %endif
 %ifarch ppc ppc64
-case "$D" in
-  ../lib64) T=ppc64-%{_vendor}-%{_os};;
-  *) T=ppc-%{_vendor}-%{_os};;
-esac
+T=ppc64-%{_vendor}-%{_os}
 %endif
 %ifarch s390 s390x
 case "$D" in
Comment 8 Jens Petersen 2006-05-09 07:22:27 EDT
made this change for FC devel in 4.2.0-0.6.20060428
Comment 9 Jens Petersen 2006-05-10 16:48:29 EDT
4.2.0-0.3.20060428.fc5.1 built for fc5 update
Comment 10 Fedora Update System 2006-05-12 00:29:35 EDT
libstdc++so7-4.2.0-0.3.20060428.fc5.1 scim-1.4.4-9.2.fc5 scim-anthy-1.0.0-1.fc5.1 scim-chewing-0.2.1-5.2 scim-hangul-0.2.2-1.fc5.1 scim-m17n-0.2.0-2.1 scim-pinyin-0.5.91-4.4 scim-tables-0.5.6-3.1 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 11 Fedora Update System 2006-05-14 13:15:16 EDT
libstdc++so7-4.2.0-0.3.20060428.fc5.1 scim-1.4.4-9.2.fc5 scim-anthy-1.0.0-1.fc5.1 scim-chewing-0.2.1-5.2 scim-hangul-0.2.2-1.fc5.1 scim-m17n-0.2.0-2.1 scim-pinyin-0.5.91-4.4 scim-tables-0.5.6-3.1 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 12 Fedora Update System 2006-05-16 13:49:12 EDT
libstdc++so7-4.2.0-0.3.20060203.3 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 13 Fedora Update System 2006-05-18 20:55:45 EDT
libstdc++so7-4.2.0-0.3.20060428.fc5.1 scim-1.4.4-9.2.fc5 scim-anthy-1.0.0-1.fc5.1 scim-chewing-0.2.1-5.2 scim-hangul-0.2.2-1.fc5.1 scim-m17n-0.2.0-2.1 scim-pinyin-0.5.91-4.4 scim-tables-0.5.6-3.1 has been pushed for fc5, which should resolve this issue.  If these problems are still present in this version, then please make note of it in this bug report.
Comment 14 A S Alam 2006-09-01 00:24:00 EDT
No Hardware available this time, next round we can try to test.
thanks

Note You need to log in before you can comment on or make changes to this bug.